#include <iostream>
using std::cout;


// a primitive "smart" array
template <class T>
class vec {
public:
   vec();
   vec(int init_cap);  // constructor, parameter is initial capacity of array 
   ~vec();
   void push_back(const T&);  // put an element onto the end of the array
                              // If not enough capacity, double the capacity
   void display() const;      // display all elements of array to cout
                                         // copy constructor
                                         // overloaded assignment operator
private:
   int capacity;    // how much space is currently available
   int size;        // how much space is currently used
   T *contents;     // pointer to array containing data
};

// Test program for the class template "vec"
int main()
{
    int i;
    vec <int> myvec;
    for (i=0; i < 10; i++)
        myvec.push_back(i);    // put the integers from 1 to 10 into the array
    myvec.display();          // display all elements of the array
    cout << endl;
}

// Here are the member functions for the class template:
// (Insert your implementation here)







